=== debian/changelog ===
vg (1.30.0+ds-1) unstable; urgency=medium

  * Try out mips64el
  * Re-enable tests on avx.
  * New upstream version
  * Refresh patches. No longer uses rocksdb.
  * Added patch to fix include path for vgio's libhandlegraph copy
  * Added patch from upstream to fix gcc-10 FTBFS
  * i386 never worked, lets not waste buildd time with it

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 27 Jan 2021 12:28:32 +0100

vg (1.29.0+ds-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)

  [ Michael R. Crusoe ]
  * find Variant.h in /usr/include/vcflib
  * update debian/clean

  [ Étienne Mollier ]
  * refresh patches
  * d/control: add build time test dependencies on tabix and xxd.
  * d/rules: reviewed calls to vg-* SIMDe variants during build time tests.
  * d/rules: disable AVX variant as one test fails
  * d/rules: abort test if vg-plain fails
  * lintian overrides: updated false positives of typos
  * spelling patch: fixed a new typo in binaries
  * provided a "whatis" description to vg manual
  * d/copyright: reorder spp_timer.h to make sure globbing maps to the proper
    license term for sparsepp, per lintian warning
  * make sure the libbz2 is dynamically linked
  * override missing source on benchmarks.js
  * add d3.js sources
  * d/control: move build dependency from librdf-dev to librdf0-dev.

 -- Étienne Mollier <etienne.mollier@mailoo.org>  Thu, 17 Dec 2020 20:53:12 +0100

vg (1.27.1+ds-1) unstable; urgency=medium

  * New upstream version
  * debian/patches/hardening_flags: refreshed patch
  * debian/patches/*: update my email address, add "Forwarded: not-needed" as
    applicable

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 05 Oct 2020 09:44:29 +0200

vg (1.26.0+ds-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * No need to fiddle around with header files dh_auto_clean override

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 28 Aug 2020 18:30:29 +0200
