=== debian/control ===
Source: vg
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pv <!nocheck>,
               bsdmainutils,
               zlib1g-dev,
               rs,
               libffi-dev,
               bwa <!nocheck>,
               protobuf-compiler,
               libprotoc-dev,
               libprotobuf-dev,
               libjansson-dev,
               libbz2-dev,
               libncurses5-dev,
               automake,
               libtool,
               jq,
               samtools <!nocheck>,
               unzip,
               librdf0-dev,
               cmake,
               pkg-config,
               bc,
               gtk-doc-tools,
               raptor2-utils <!nocheck>,
               rasqal-utils <!nocheck>,
               bison,
               flex,
               gawk,
               liblz4-dev,
               liblzma-dev,
               libcairo2-dev,
               libpixman-1-dev,
               libssw-dev,
               libdeflate-dev,
               libboost-program-options-dev,
               libjemalloc-dev,
               libbackward-cpp-dev,
               elfutils,
               libdw-dev,
               libelf-dev,
               libraptor2-dev,
               libsparsehash-dev,
               rapidjson-dev,
               libfml-dev,
               libfastahack-dev,
               fastahack <!nocheck>,
               tabix <!nocheck>,
               xxd <!nocheck>,
               libsmithwaterman-dev,
               libdivsufsort-dev,
               libtsl-hopscotch-map-dev,
               libvcflib-dev (>= 1.0.1),
               libvcflib-tools <!nocheck>,
               libhts-dev,
               help2man <!nodoc>,
               python3:any,
               libsimde-dev
#              libsdsl-dev,
#              libvw-dev,
#              redland-utils,  # not needed?
Build-Depends-Indep: doxygen <!nodoc>,
                     graphviz <!nodoc>
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/vg
Vcs-Git: https://salsa.debian.org/med-team/vg.git
Homepage: https://github.com/vgteam/vg#vg
Rules-Requires-Root: no

Package: vg
Built-Using: ${simde:Built-Using}
Architecture: amd64 arm64 ppc64el mips64el s390x riscv64 x32
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: cgvg
Description: tools for working with genome variation graphs
 variation graph data structures, interchange formats, alignment, genotyping,
 and variant calling methods
 .
 Variation graphs provide a succinct encoding of the sequences of many genomes.
 A variation graph (in particular as implemented in vg) is composed of:
 .
  - nodes, which are labeled by sequences and ids
  - edges, which connect two nodes via either of their respective ends
  - paths, describe genomes, sequence alignments, and annotations (such as gene
   models and transcripts) as walks through nodes connected by edges
 .
 This model is similar to a number of sequence graphs that have been used in
 assembly and multiple sequence alignment. Paths provide coordinate systems
 relative to genomes encoded in the graph, allowing stable mappings to be
 produced even if the structure of the graph is changed.

Package: vg-docs
Architecture: all
Section: doc
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: tools for working with genome variation graphs -- docs
 variation graph data structures, interchange formats, alignment, genotyping,
 and variant calling methods
 .
 Variation graphs provide a succinct encoding of the sequences of many genomes.
 A variation graph (in particular as implemented in vg) is composed of:
 .
  - nodes, which are labeled by sequences and ids
  - edges, which connect two nodes via either of their respective ends
  - paths, describe genomes, sequence alignments, and annotations (such as gene
   models and transcripts) as walks through nodes connected by edges
 .
 This model is similar to a number of sequence graphs that have been used in
 assembly and multiple sequence alignment. Paths provide coordinate systems
 relative to genomes encoded in the graph, allowing stable mappings to be
 produced even if the structure of the graph is changed.
 .
 This package provides the documentation
