=== debian/tests/control ===
Test-Command: vg test
Depends: vg, libvcflib-tools
Restrictions: allow-stderr, skip-not-installable
